// mbl@lri.fr - 2013 - Simple text chat (server)

// First, import the net module
var net = require("net");

// Then, create a server. The callback 'newClient' is called when a client connects
var server = net.createServer(newClient);

// This array will hold the set of connected clients
var clients = [];

// This gets called when a new client connects
function newClient(socket) {
	console.log('newClient');

	// Record the new client
	clients.push(socket);

	// Say hello to the client
	socket.write("Welcome to netchat\n");

	// Set up an event handler when data arrives from the client
	socket.on('data', function(data) {
		messageFrom(socket, data);
	});

	// Set up another handler when the client disconnects
	socket.on('end', function() {
		byeClient(socket);
	});
}

// This gets called when a client sends a message
function messageFrom(socket, data) {
	console.log('message');

	// Send the message to all other clients
	for (var i = 0; i < clients.length; i++) {
		var s = clients[i];
		if (s != socket)	// We don't want to send it back to the sender
			s.write(data);
	};
}

// This gets called when a client disconnects
function byeClient(socket) {
	console.log('byeClient');

	// Remove the client from the array
	var i = clients.indexOf(socket);
	if (i >= 0)
		clients.splice(i, 1);
}

// Finally launch the server on a port number and say we're ready
server.listen(7000, function() {
	console.log('netchat server ready');
});
