// mbl@lri.fr - 2013 - Simple web chat (server)

// === Create a simple web server to serve the client page ===

// Import express and create a webserver app
var express = require('express');
var webserver = express();

// Serve local files
webserver.use(express.static(__dirname));

// === Setup the server for websocket connections ===

// Use socket.io to create a server called 'io'
var server = require('http').createServer(webserver);
var io = require('socket.io').listen(server);
io.set('log level', 1);	// 0-error, 1-warning, 2-info, 3-debug (default)

// Set up a handler when a new client connects
io.sockets.on('connection', newClient);

// This gets called when a new client connects
function newClient(socket) {
	console.log('newClient');

	// Say hello to the client
	socket.emit("Welcome to netchat\n");

	// Set up an event handler when data arrives from the client
	socket.on('message', function(msg) {
		messageFrom(socket, msg);
	})

	// Set up another handler when the client disconnects
	socket.on('disconnect', function() {
		byeClient(socket);
	})
}

// This gets called when a client sends a message
function messageFrom(socket, msg) {
	console.log('message');

	// Send the message to all other clients
	socket.broadcast.emit('message', msg)
}

// This gets called when a client disconnects
function byeClient(socket) {
	console.log('byeClient');
}

// Start the server
server.listen(8080);
console.log('Webchat server ready. Point your browser to http://localhost:8080/chat.html');
